<?php

use \Setforms2\Runtime\Connection;
use \Setforms2\Runtime\Strategy\Strategy;
/**
 * Estrategia para geracao de alfanumericos sequenciais.
 *
 * @package Strategy
 * @author  thalesvalias 20/04/2012
 *
 */
class GeraIdAlfanumericoStrategy extends Strategy{


    /**
     * Executa estrategia.
     *
     * @see TkStrategyAbstract::execute()
     *
     * @return void
     *
     * @author tuliobraga/alessandrobartels 08/08/2011
     *         alessandrobartels 18/05/2012 - Modificado devido a nova implementacao do Strategy.
     */
    public function execute()
    {
        $tableName = $this->getTableName();
        $pk = $this->getPkColumns();
        $data = $this->getData();
        $colunas = $this->getColumns();
        $columnName = $this->getColumnName();
        $step = $this->getStep();
        $parametros = $this->getParams(); /* A primeira posicao do array de parametros eh a '1'. */

        // Quando o valor da coluna for vazio gera um novo id alfanumerico.
        if (empty($data[$columnName]) === true) {
            return $this->getId($columnName, $tableName, $step, $pk, $parametros);
        } else {
            return $data[$columnName];
        }
    }


    public static function getId($columnName, $tableName, $step, $pk, $params = null)
    {
        $db = Connection::getInstance()->getConn();
        if (count($pk) > 1) {
            $query = "SELECT MAX({$columnName}) FROM {$tableName} where {$params[0]}";
        }

        $max = $db->execute($query)->fetchColumn(0);
        $numerica = null;
        if ($max) {
            list($alfa, $numerica) = explode($params[2], $max);
        }

        $max = (int)$numerica + $step;
        $max = str_pad($max, ($params[1]-strlen($params[2])), '0', STR_PAD_LEFT);

        return $params[2].$max;
    }


}
