<?php
/**
 * Namespace Vendas\Repositories
 *
 * PHP version 5
 *
 * @category Php
 * @package  Vendas\Repositories
 * @author   andreteixeira <andre.teixeira@teknisa.com>
 * @license  www.teknisa.com Teknisa
 * @link     http://localhost:9090/tecfood
 */
namespace Vendas\Repositories;

/**
 * Class Nvsubgrprod
 *
 * PHP version 5
 *
 * @category Php
 * @package  Vendas\Repositories
 * @author   andreteixeira <andre.teixeira@teknisa.com>
 * @license  www.teknisa.com Teknisa
 * @link     http://localhost:9090/tecfood
 */
class Nvsubgrprod extends \Doctrine\ORM\EntityRepository
{

    /**
     * Deleta todos os registros de determinado subgrupo.
     *
     * @param String $nrorg       Organização
     * @param String $cdgrupprod  Grupo
     * @param String $cdsubgrprod Subgrupo
     *
     * @return null
     * @throws \Exception
     */
    public static function deletaRegistrosPorSubgrupo (
        $nrorg, $cdgrupprod, $cdsubgrprod = 'A'
    ) {
        $sql = <<<SQL
        DELETE FROM NVSUBGRPROD
        WHERE NRORG        = :NRORG
          AND CDGRUPPROD   = :CDGRUPPROD
          AND (CDSUBGRPROD = :CDSUBGRPROD
           OR :CDSUBGRPROD = 'A')
SQL;

        $params = array(
            'NRORG'       => $nrorg,
            'CDGRUPPROD'  => $cdgrupprod,
            'CDSUBGRPROD' => $cdsubgrprod
        );

        try{
            return \Setforms2\Shared\Connection::getInstance()->execute($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }

    }

}